import React, { useContext } from 'react';
import AppBar from '@mui/material/AppBar';
import Avatar from '@mui/material/Avatar';
import Box from '@mui/material/Box';
import IconButton from '@mui/material/IconButton';
import Toolbar from '@mui/material/Toolbar';
import Typography from '@mui/material/Typography';
import ExitToAppIcon from '@mui/icons-material/ExitToApp';
import { default as VuetifyLogo } from '../logo.svg';
import { AuthContext } from '../AuthContext';

const Bar = () => {
  const { username, handleLogout } = useContext(AuthContext);

  return (
    <AppBar position="static">
    <Toolbar>
      <Box display="flex" alignItems="center" flexGrow={1}>
        <IconButton edge="start" color="inherit" aria-label="menu">
          <img src={VuetifyLogo} alt="Vuetify Logo" width="40" />
        </IconButton>
      </Box>
      {username && (
        <Box display="flex" alignItems="center" marginRight="1rem">
          <Avatar>{username.charAt(0).toUpperCase()}</Avatar>
          <Typography variant="subtitle1" style={{ marginLeft: '1rem' }}>
            {username}
          </Typography>
        </Box>
      )}
      <IconButton edge="end" color="inherit" aria-label="logout" onClick={handleLogout}>
        <ExitToAppIcon />
      </IconButton>
    </Toolbar>
  </AppBar>
  );
};

export default Bar;